/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Patrick Boenzli
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_SPATIAL_SEPARATION

#include "quadtree.h"
#include "quadtree_node.h"

using namespace std;


/**
 *  standard constructor
   @todo this constructor is not jet implemented - do it
*/
Quadtree::Quadtree (modelInfo* pModelInfo)
{
   this->setClassID(CL_QUADTREE, "Quadtree");
   this->pModelInfo = pModelInfo;

   this->rootNode = new QuadtreeNode(this->pModelInfo);
}


/**
 *  standard deconstructor

*/
Quadtree::~Quadtree ()
{
  // delete what has to be deleted here
}


/**
 *  gives the signal to separate the model into a quadtree
 */
void Quadtree::separate()
{
  this->rootNode->separateNode();
}


/**
 *  gives the signal to separate the model into a quadtree
 */
void Quadtree::separate(int treeDepth)
{
  this->rootNode->separateNode(treeDepth);
}


/**
 *  gives the signal to separate the model into a quadtree
 */
void Quadtree::separate(float minLength)
{
  this->rootNode->separateNode(minLength);
}


/**
 *  draws the debug quadtree boxes around the model
 */
void Quadtree::drawTree(int depth, int drawMode) const
{}
